#include <stdio.h>
#include <math.h>
#include <stdlib.h>
//____________________
double input(char [], int);
int length(double, double);
double algorithm(double, int, int);
void build(double [], int, double);
void output(double [], int);

int main(void){
	double x = input("Sisesta x: ", 0);
	double epsilon = input("Sisesta e: ", 1);
	int l = length(x, epsilon);
	double C[l];
	build(C, l, x);
	output(C, l);
	return 0;
}

double input(char text[], int condition){
	double number;
	printf(text);
	if (condition == 0){
		scanf("%lf", &number);
		return number;
	}
	scanf("%lf", &number);
	if (number <= 0 || number >= 1){
		return input("epsilon peab olema vahemikus 0<e<1: ", 1);
	}
	return number;
}

int length(double x, double epsilon){
	int number, temp, a = 1, count = 1;
	while (count < 16){
		if (count > 1){
			number = algorithm(x, a, count);
			temp = count - 1;
			if (abs(number - algorithm(x, a, temp)) <= epsilon){
				break;
			}
		}
		else{
			number = algorithm(x, a, count);
			if (abs(number - x) <= epsilon){
				break;
			}
		}
		a = a + 2;
		count++;
	}
	return count;
}

double algorithm(double x, int a, int count){
	double number;
	int f, factorial = 1;
	for (f = 1; f < a + 1; f++){
			factorial = factorial * f;
	}
	if ((count % 2) == 0){
		number = (x * pow(x, count)) / factorial;
	}
	else{
		number = (-x * pow(x, count)) / factorial;
	}
	return number;
}

void build(double C[], int l, double x){
	int i, a = 1;
	C[0] = x;
	if (l > 0){
		for (i = 1; i < (l + 1); i++){
			a = a + 2;
			C[i] = algorithm(x, a, i);
		}
	}
}

void output(double C[], int l){
	int i;
	printf("Elementide arv: %d", l);
	for (i = 0; i < l; i++){
		printf("\nC%d = %lf", i + 1, C[i]);
	}
}

